function callbacks
global objekte

switch get(gcbo,'tag')
    
case {'x0','y0','vx0','vy0'}     
    [x0,y0,vx0,vy0]=get_value({'x0','y0','vx0','vy0'});
    y0=[x0,y0,vx0,vy0];
    E=0.5*(y0(1).^2+y0(2).^2+y0(3).^2+y0(4).^2)+y0(1).^2.*y0(2)-(1/3)*y0(2).^3;
    set_value('Gesamtenergie',E)
    
    set_value('zoom_energie',E)
    set_value('zoom_x0',x0)
    set_value('zoom_y0',y0(2))
    set_value('zoom_vx0',vx0)
    set_value('zoom_vy0',vy0)
    
case {'Rechnen','darstellung','anzeigen'}
    
    if strcmp(get(gcbo,'tag'),'Rechnen')
        
        [x0,y0,vx0,vy0,perioden,perioden_schritte,tau,schranke]=...
            get_value({'x0','y0','vx0','vy0','perioden','perioden_schritte','tau','schranke'});
        anf=[x0,y0,vx0,vy0];
        merken=perioden_schritte*perioden;
        
        disable_enable('enable_off','Zoom','Rechnen','x0','y0','vx0','vy0')
                
        set_graph_prop('Rechnen','foregroundcolor','r')
        pause(0.001)
        tic
        
        %poincare_main
        [r,v,poin,iter,abweichungen]=poincare_verlet_fortran(anf,tau,schranke,perioden,merken);
        zeit=toc;
        set_value('zeit',zeit)
        
        set_graph_prop('Rechnen','foregroundcolor','k')
        disable_enable('enable_on','Zoom','Rechnen','x0','y0','vx0','vy0')        
        
        poin_index=find(abs(sum(poin,2))>0);
        poin2=poin(poin_index,:);
        perioden_ok=iter/perioden_schritte;
        set_value('perioden_ok',perioden_ok)

        index=find((abs(r(:,1))+abs(r(:,2)))>0);

        objekte.variable.y0=anf;
        objekte.variable.t=2*pi*linspace(0,perioden_ok,length(index));
        objekte.variable.y=[r(index,1:2),v(index,1:2)];
        objekte.variable.ye=poin2;   
        objekte.variable.abweichungen=abweichungen;   

        [y0,t,y,ye]=deal(objekte.variable.y0,objekte.variable.t,objekte.variable.y,objekte.variable.ye);
      
        set_value('anzeigen',1)
        disable_enable('enable_on','hinzu')

    end

    [y0,t,y,poin2]=deal(objekte.variable.y0,objekte.variable.t,objekte.variable.y,objekte.variable.ye);
    
    
    [darstellung,anzeige]=get_value({'darstellung','anzeigen'});
    
    disable_enable('visible_on','xl','yl','tit')
    disable_enable('enable_on','darstellung')
    
    if strcmp(get(gcbo,'tag'),'Rechnen')
        anz=objekte.variable.anzahl;
    else
        anz=max(objekte.variable.anzahl-1,0);
    end
    
    objekte.variable.Y(anz+1).ye_i1_x0=poin2(find(poin2(:,5)==1),:);
    objekte.variable.Y(anz+1).ye_i1_x0_yplus=poin2(find(poin2(:,5)==1 & poin2(:,3)>0),:);
    objekte.variable.Y(anz+1).ye_i1_x0_yminus=poin2(find(poin2(:,5)==1 & poin2(:,3)<0),:);
    objekte.variable.Y(anz+1).ye_i1_y0=poin2(find(poin2(:,5)==2),:);
    objekte.variable.Y(anz+1).ye_i1_yo_xplus=poin2(find(poin2(:,5)==2 & poin2(:,4)>0),:);
    objekte.variable.Y(anz+1).ye_i1_yo_xminus=poin2(find(poin2(:,5)==2 & poin2(:,4)<0),:);;
        
    abweichungen=objekte.variable.abweichungen;   

    switch anzeige
    case 1
        for i=1:15
            disable_enable('visible_off',strcat('graphik_',num2str(i))) 
            disable_enable('visible_on',strcat('graphik_',num2str(anz+1))) 
        end
    case 2
        for i=1:15
            disable_enable('visible_on',strcat('graphik_',num2str(i))) 
        end
    end
    
    
    for i=1:(anz+1)
        Y(i).ye_i1_x0=objekte.variable.Y(i).ye_i1_x0;
        Y(i).ye_i1_x0_yplus=objekte.variable.Y(i).ye_i1_x0_yplus;
        Y(i).ye_i1_x0_yminus=objekte.variable.Y(i).ye_i1_x0_yminus;
        Y(i).ye_i1_y0=objekte.variable.Y(i).ye_i1_y0;
        Y(i).ye_i1_yo_xplus=objekte.variable.Y(i).ye_i1_yo_xplus;
        Y(i).ye_i1_yo_xminus=objekte.variable.Y(i).ye_i1_yo_xminus;
    end
    
%     switch anzeige
%     case 1
%         ye_i1_x0=objekte.variable.ye_i1_x0;
%         ye_i1_x0_yplus=objekte.variable.ye_i1_x0_yplus;
%         ye_i1_x0_yminus=objekte.variable.ye_i1_x0_yminus;
%         ye_i1_y0=objekte.variable.ye_i1_y0;
%         ye_i1_yo_xplus=objekte.variable.ye_i1_yo_xplus;
%         ye_i1_yo_xminus=objekte.variable.ye_i1_yo_xminus;
%     case 2
%         ye_i1_x0=objekte.variable.alle_ye_i1_x0;
%         ye_i1_x0_yplus=objekte.variable.alle_ye_i1_x0_yplus;
%         ye_i1_x0_yminus=objekte.variable.alle_ye_i1_x0_yminus;
%         ye_i1_y0=objekte.variable.alle_ye_i1_y0;
%         ye_i1_yo_xplus=objekte.variable.alle_ye_i1_yo_xplus;
%         ye_i1_yo_xminus=objekte.variable.alle_ye_i1_yo_xminus;        
%     end
    
    
%     switch darstellung
%     case 1
%         set_graph_prop('graphik','xdata',y(:,1),'ydata',y(:,2),'Marker','none','Linestyle','-') 
%         set_graph_prop('xl','string','x'); set_graph_prop('yl','string','y'); set_graph_prop('tit','string','Teilchenbahn')
%     case 2
%         set_graph_prop('graphik','xdata',t,'ydata',y(:,1),'Marker','none','Linestyle','-')          
%         set_graph_prop('xl','string','Zeit t'); set_graph_prop('yl','string','x'); set_graph_prop('tit','string','x(t)')    
%     case 3
%         set_graph_prop('graphik','xdata',t,'ydata',y(:,2),'Marker','none','Linestyle','-')
%         set_graph_prop('xl','string','Zeit t'); set_graph_prop('yl','string','y'); set_graph_prop('tit','string','y(t)')            
%     case 4
%         set_graph_prop('graphik','xdata',y(:,1),'ydata',y(:,3),'Marker','none','Linestyle','-')   
%         set_graph_prop('xl','string','x'); set_graph_prop('yl','string','v_x'); set_graph_prop('tit','string','Phasenraumausschnitt (x-Komp.)')                    
%     case 5
%         set_graph_prop('graphik','xdata',y(:,2),'ydata',y(:,4),'Marker','none','Linestyle','-')                  
%         set_graph_prop('xl','string','y'); set_graph_prop('yl','string','v_y'); set_graph_prop('tit','string','Phasenraumausschnitt (y-Komp.)')                        
%     case 6
%         set_graph_prop('graphik','xdata',ye_i1_x0(:,2),'ydata',ye_i1_x0(:,4),'Marker','.','Linestyle','none') 
%         set_graph_prop('xl','string','y'); set_graph_prop('yl','string','v_y'); set_graph_prop('tit','string','Poincare Schnitt (x = 0)')                    
%     case 7
%         set_graph_prop('graphik','xdata',ye_i1_x0_yplus(:,2),'ydata',ye_i1_x0_yplus(:,4),'Marker','.','Linestyle','none')   
%         set_graph_prop('xl','string','y'); set_graph_prop('yl','string','v_y'); set_graph_prop('tit','string','Poincare Schnitt (x = 0, v_x > 0)')                    
%     case 8
%         set_graph_prop('graphik','xdata',ye_i1_x0_yminus(:,2),'ydata',ye_i1_x0_yminus(:,4),'Marker','.','Linestyle','none')   
%         set_graph_prop('xl','string','y'); set_graph_prop('yl','string','v_y'); set_graph_prop('tit','string','Poincare Schnitt (x = 0, v_x < 0)')                    
%     case 9
%         set_graph_prop('graphik','xdata',ye_i1_y0(:,1),'ydata',ye_i1_y0(:,3),'Marker','.','Linestyle','none')
%         set_graph_prop('xl','string','x'); set_graph_prop('yl','string','v_x'); set_graph_prop('tit','string','Poincare Schnitt (y = 0)')                            
%     case 10
%         set_graph_prop('graphik','xdata',ye_i1_yo_xplus(:,1),'ydata',ye_i1_yo_xplus(:,3),'Marker','.','Linestyle','none')   
%         set_graph_prop('xl','string','x'); set_graph_prop('yl','string','v_x'); set_graph_prop('tit','string','Poincare Schnitt (y = 0, v_y > 0)')                        
%     case 11
%         set_graph_prop('graphik','xdata',ye_i1_yo_xminus(:,1),'ydata',ye_i1_yo_xminus(:,3),'Marker','.','Linestyle','none')   
%         set_graph_prop('xl','string','x'); set_graph_prop('yl','string','v_x'); set_graph_prop('tit','string','Poincare Schnitt (y = 0, v_y < 0)')  
%     case 12
%         set_graph_prop('graphik','xdata',t,'ydata',abweichungen(1:length(t)),'Marker','none','Linestyle','-') 
%         set_graph_prop('xl','string','t'); set_graph_prop('yl','string','Abweichung'); set_graph_prop('tit','string','Diff. zu 2 facher Genauigkeit')
%     end

switch darstellung
case 1
    set_graph_prop('graphik_1','xdata',y(:,1),'ydata',y(:,2),'Marker','none','Linestyle','-') 
    set_graph_prop('xl','string','x'); set_graph_prop('yl','string','y'); set_graph_prop('tit','string','Teilchenbahn')
    for i=2:15
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',[],'ydata',[])
    end
case 2
    set_graph_prop('graphik_1','xdata',t,'ydata',y(:,1),'Marker','none','Linestyle','-')          
    set_graph_prop('xl','string','Zeit t'); set_graph_prop('yl','string','x'); set_graph_prop('tit','string','x(t)')    
    for i=2:15
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',[],'ydata',[])
    end
case 3
    set_graph_prop('graphik_1','xdata',t,'ydata',y(:,2),'Marker','none','Linestyle','-')
    set_graph_prop('xl','string','Zeit t'); set_graph_prop('yl','string','y'); set_graph_prop('tit','string','y(t)')   
    for i=2:15
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',[],'ydata',[])
    end
case 4
    set_graph_prop('graphik_1','xdata',y(:,1),'ydata',y(:,3),'Marker','none','Linestyle','-')   
    set_graph_prop('xl','string','x'); set_graph_prop('yl','string','v_x'); set_graph_prop('tit','string','Phasenraumausschnitt (x-Komp.)')                    
    for i=2:15
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',[],'ydata',[])
    end    
case 5
    set_graph_prop('graphik_1','xdata',y(:,2),'ydata',y(:,4),'Marker','none','Linestyle','-')  
    set_graph_prop('xl','string','y'); set_graph_prop('yl','string','v_y'); set_graph_prop('tit','string','Phasenraumausschnitt (y-Komp.)')                        
    for i=2:15
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',[],'ydata',[])
    end    
case 6
    for i=1:anz+1
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',Y(i).ye_i1_x0(:,2),'ydata',Y(i).ye_i1_x0(:,4),'Marker','.','Linestyle','none') 
    end
    set_graph_prop('xl','string','y'); set_graph_prop('yl','string','v_y'); set_graph_prop('tit','string','Poincare Schnitt (x = 0)')                    
case 7
    for i=1:anz+1
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',Y(i).ye_i1_x0_yplus(:,2),'ydata',Y(i).ye_i1_x0_yplus(:,4),'Marker','.','Linestyle','none')   
    end
    set_graph_prop('xl','string','y'); set_graph_prop('yl','string','v_y'); set_graph_prop('tit','string','Poincare Schnitt (x = 0, v_x > 0)')                    
case 8
    for i=1:anz+1
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',Y(i).ye_i1_x0_yminus(:,2),'ydata',Y(i).ye_i1_x0_yminus(:,4),'Marker','.','Linestyle','none')   
    end
    set_graph_prop('xl','string','y'); set_graph_prop('yl','string','v_y'); set_graph_prop('tit','string','Poincare Schnitt (x = 0, v_x < 0)')                    
case 9
    for i=1:anz+1
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',Y(i).ye_i1_y0(:,1),'ydata',Y(i).ye_i1_y0(:,3),'Marker','.','Linestyle','none')
    end
    set_graph_prop('xl','string','x'); set_graph_prop('yl','string','v_x'); set_graph_prop('tit','string','Poincare Schnitt (y = 0)')                            
case 10
    for i=1:anz+1
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',Y(i).ye_i1_yo_xplus(:,1),'ydata',Y(i).ye_i1_yo_xplus(:,3),'Marker','.','Linestyle','none')   
    end
    set_graph_prop('xl','string','x'); set_graph_prop('yl','string','v_x'); set_graph_prop('tit','string','Poincare Schnitt (y = 0, v_y > 0)')                        
case 11
    for i=1:anz+1
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',Y(i).ye_i1_yo_xminus(:,1),'ydata',Y(i).ye_i1_yo_xminus(:,3),'Marker','.','Linestyle','none')   
    end
    set_graph_prop('xl','string','x'); set_graph_prop('yl','string','v_x'); set_graph_prop('tit','string','Poincare Schnitt (y = 0, v_y < 0)')                            
case 12
    set_graph_prop('graphik_1','xdata',t,'ydata',abweichungen(1:length(t)),'Marker','none','Linestyle','-') 
    set_graph_prop('xl','string','t'); set_graph_prop('yl','string','Abweichung'); set_graph_prop('tit','string','Diff. zu 2 facher Genauigkeit')    
    for i=2:15
        set_graph_prop(strcat('graphik_',num2str(i)),'xdata',[],'ydata',[])
    end
end
axis tight
    
    
case 'hinzu'
    
    objekte.variable.anzahl=objekte.variable.anzahl+1;
    anz=objekte.variable.anzahl;
    
    objekte.variable.Y(anz).ye_i1_x0=objekte.variable.Y(anz).ye_i1_x0;
    objekte.variable.Y(anz).ye_i1_x0_yplus=objekte.variable.Y(anz).ye_i1_x0_yplus;
    objekte.variable.Y(anz).ye_i1_x0_yminus=objekte.variable.Y(anz).ye_i1_x0_yminus;
    objekte.variable.Y(anz).ye_i1_y0=objekte.variable.Y(anz).ye_i1_y0;
    objekte.variable.Y(anz).ye_i1_yo_xplus=objekte.variable.Y(anz).ye_i1_yo_xplus;
    objekte.variable.Y(anz).ye_i1_yo_xminus=objekte.variable.Y(anz).ye_i1_yo_xminus;
    
    disable_enable('enable_off','hinzu')
    
    disable_enable('enable_on','anzeigen')
    disable_enable('visible_on',strcat('graphik_',num2str(objekte.variable.anzahl))) 

   
    
case 'loeschen'
    
    disable_enable('enable_off','anzeigen')
    set_value('anzeigen',1)
    objekte.variable.anzahl=0;
    
end
