% erstellt den Hilfstext, ladet Text aus text_file, verwendet die ui-tags tag_text und tag_slider
function make_help(tag_text,tag_slider,text_file)
global objekte

if ~strcmp(get(gcbo,'tag'),'ui_help_slider')
    
    fid=fopen(text_file);
    j=0;
    while 1
        j=j+1;
        tline = (fgetl(fid));
        if tline<0
            break
        end
        txt{j}=tline;   
    end
    
    ui_text_han=find_handle(objekte.han,'tag',tag_text);
    ui_slider_han=find_handle(objekte.han,'tag',tag_slider);
    
    pos_alt=get(ui_text_han,'position');
    
    [outstring,newpos] = textwrap(ui_text_han,txt);
    
    zeilen=length(outstring);
    zeilen_seite=floor(zeilen/(newpos(4)/0.8));
    
    if newpos(4)>pos_alt(4)
        set(ui_slider_han,'max',-zeilen_seite,'min',-zeilen,'value',-zeilen_seite)
    end
    
    set(ui_text_han,'String',char(outstring(1:min(zeilen,zeilen_seite),:)),'horizontalalignment','left')
    if zeilen<=zeilen_seite
        disable_enable('visible_off',tag_slider)    
    end
    
    objekte.variable.hilfstext=outstring;
    objekte.variable.ui_text_han=ui_text_han;
    objekte.variable.zeilen=zeilen_seite;
    objekte.variable.tag_text=tag_text;
else
    txt=objekte.variable.hilfstext;
    h=find_handle(objekte.han,'tag',objekte.variable.tag_text);
    
    zeilen_seite=objekte.variable.zeilen;
    
    wert=abs(ceil(get(gcbo,'value')));
    
    set(h,'string',txt((wert+1-zeilen_seite):wert))
end