%clear all
close all

anf = [0.2,0.1,0.4,0.3]
E = 0.5*(anf(1)^2+anf(2)^2+anf(3)^2+anf(4)^2)+anf(1)^2*anf(2)-(anf(2)^3)/3

tau=0.0001;
perioden=40;
merken_pro_periode=100;

iterationen=round(perioden*2*pi/tau);

merken=merken_pro_periode*perioden;
schranke=0.01;

tic
[r,v,poin,iter,abweichungen]=poincare_verlet_fortran(anf,tau,schranke,perioden,merken);
zeit=toc

iter
iterationen

perioden_ok=perioden*iter/iterationen

index=find((abs(r(:,1))+abs(r(:,2)))>0);

figure
plot(r(index,1),r(index,2))
axis equal

figure
plot(r(index,1),r(index,2))
hold on
plot(r(index,3),r(index,4),'r')
axis equal


figure
plot3(r(index,3)-r(index,1),r(index,4)-r(index,2),1:length(r(index,3)))
grid on

poin_index=find(abs(sum(poin,2))>0);
poin2=poin(poin_index,:);

ind1=find(poin2(:,5)==1);
figure
plot(poin2(ind1,2),poin2(ind1,4),'.')

ind2=find(poin2(:,5)==2);
figure
plot(poin2(ind2,1),poin2(ind2,3),'.')

figure
plot((1:merken)/merken_pro_periode,abweichungen)