%erstellt Titelleiste in der Achse mit dem tag tag
function make_title(tag,varargin)

global objekte
alle_handles=objekte.han;
h1=find_handle(alle_handles,'type','axes','tag',tag);

set(h1,'Position',get_userdata(h1,'Position_alt'))
axes(h1)
axis off

ptf=get(h1,'position');

logo_y=ptf(4);

if nargin==4
    logos=varargin(3);
    logo_zahl=length(logos{1});
else
    logo_zahl=0;
end
texte=varargin(1);
texte_zahl=length(texte{1});

h2=sign(texte_zahl)*3+logo_zahl;
logo_xy=min(logo_y,ptf(3)/h2);


% 1 oder 2 Logos anbringen
if nargin==4
    for i=1:logo_zahl
        if i==1
            pos_logo=[ptf(1)+0.05*logo_xy,ptf(2)+0.05*logo_y,0.9*logo_xy,0.9*logo_y];
        else
            pos_logo=[ptf(1)+ptf(3)-0.95*logo_xy,ptf(2)+0.05*logo_y,0.9*logo_xy,0.9*logo_y];
        end
        axes('pos',pos_logo)
        image(logos{1}{i})
        axis off
    end
else
    logo_zahl=0;
end
if ~isempty((varargin(1)))
    fosi=varargin(2);
    switch logo_zahl
    case 0
        pos_text=ptf;
    case 1
        pos_text=[ptf(1)+logo_xy,ptf(2),ptf(3)-logo_xy,ptf(4)];
    case 2
        pos_text=[ptf(1)+logo_xy,ptf(2),ptf(3)-2*logo_xy,ptf(4)];   
    end
    
    for i=1:texte_zahl
        
        uicontrol('units','normalized',...
            'position',[pos_text(1),pos_text(2)+pos_text(4)-i*pos_text(4)/texte_zahl,pos_text(3),pos_text(4)/texte_zahl],...
            'style','text',...
            'string',texte{1}{i},...
            'horizontalalignment','center',...
            'backgroundcolor',[1,1,1],...
            'fontunits','normalized',...
            'fontsize',fosi{1}{i})            
    end
end