SUBROUTINE mexfunction(nlhs, plhs, nrhs, prhs)
  USE matlab_mod

  INTEGER nlhs, nrhs
  INTEGER plhs(*), prhs(*)

  ! New declaration for the pointers.
  INTEGER, POINTER :: pr_in_anf, pr_in_tau, pr_in_schranke
  INTEGER, POINTER :: pr_out_r, pr_out_v, pr_out_poin,pr_out_i, pr_out_abweichungen

  DOUBLE PRECISION iterationen, merken

  pr_in_anf       => mxgetpr(prhs(1))
  pr_in_tau       => mxgetpr(prhs(2))
  pr_in_schranke  => mxgetpr(prhs(3))

  iterationen  = mxgetscalar(prhs(4))
  merken       = mxgetscalar(prhs(5))
 
  plhs(1) = mxcreatefull(INT(merken),4,0)  
  plhs(2) = mxcreatefull(INT(merken),4,0)  
  plhs(3) = mxcreatefull(INT(merken),5,0)  
  plhs(4) = mxcreatefull(1,1,0)  
  plhs(5) = mxcreatefull(INT(merken),1,0)  

  pr_out_r                  => mxgetpr(plhs(1))
  pr_out_v                  => mxgetpr(plhs(2))
  pr_out_poin               => mxgetpr(plhs(3))
  pr_out_i                  => mxgetpr(plhs(4))
  pr_out_abweichungen       => mxgetpr(plhs(5))

  CALL poincare_verlet_fortran(pr_out_r, pr_out_v, pr_out_poin, pr_out_i, pr_out_abweichungen,pr_in_anf, &
       &pr_in_tau, pr_in_schranke, iterationen, merken)

END SUBROUTINE mexfunction
